Mango.Web/Controllers/CartController.cs
using System.Net;
using System.Text.Json.Serialization;
using Mango.Web.Models;
using Mango.Web.Services.Interfaces;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;

namespace Mango.Web.Controllers;

public class CartController : Controller
{
    private readonly IProductService _productService;
    private readonly ICartService _cartService;
    private readonly ICouponService _couponService;


    public CartController(
        ICartService cartService, 
        IProductService productService, 
        ICouponService couponService)
    {
        _cartService = cartService;
        _productService = productService;
        _couponService = couponService;
    }

    // GET
    public async Task<IActionResult> Index()
    {
        return View(await LoadCartDtoBaseOnLoggedInUser());
    }
    
    public async Task<IActionResult> Checkout()
    {
        return View(await LoadCartDtoBaseOnLoggedInUser());
    }
    
    [HttpPost]
    public async Task<IActionResult> Checkout(CartDto cartDto)
    {
        try
        {
            var accessToken = await HttpContext.GetTokenAsync("access_token");
            var response = await _cartService.Checkout<ResponseDto>(accessToken, cartDto.CartHeader);

            if (!response.IsSuccess)
            {
                TempData["Error"] = response.DisplayMessage;
                return RedirectToAction(nameof(Checkout));
            }
            
            return RedirectToAction(nameof(Confirmation));
        }
        catch
        {
            return View(cartDto);
        }
    }
    
    public async Task<IActionResult> Confirmation()
    {
        return View();
    }
    
    public async Task<IActionResult> Remove(int cartDetailsId)
    {
        var accessToken = await HttpContext.GetTokenAsync("access_token");

        var response = await _cartService.RemoveFromCart<ResponseDto>(accessToken, cartDetailsId);
        if (response?.IsSuccess ?? false)
        {
            return RedirectToAction(nameof(Index));
        }

        //TODO: add validation message
        return RedirectToAction(nameof(Index));
    }

    [HttpPost]
    public async Task<IActionResult> ApplyCoupon(CartDto cartDto)
    {
        var accessToken = await HttpContext.GetTokenAsync("access_token");

        var response = await _cartService.ApplyCoupon<ResponseDto>(accessToken, cartDto);
        if (response?.IsSuccess ?? false)
        {
            return RedirectToAction(nameof(Index));
        }

        //TODO: add validation message
        return RedirectToAction(nameof(Index));
    }
    
    [HttpPost]
    public async Task<IActionResult> RemoveCoupon(CartDto cartDto)
    {
        var accessToken = await HttpContext.GetTokenAsync("access_token");

        var response = await _cartService.RemoveCoupon<ResponseDto>(accessToken, cartDto.CartHeader.UserId);
        if (response?.IsSuccess ?? false)
        {
            return RedirectToAction(nameof(Index));
        }

        //TODO: add validation message
        return RedirectToAction(nameof(Index));
    }

    private async Task<CartDto> LoadCartDtoBaseOnLoggedInUser()
    {
        var userId = User.Claims.FirstOrDefault(x => x.Type == "sub")?.Value;
        var accessToken = await HttpContext.GetTokenAsync("access_token");

        var response = await _cartService.GetCartByUserId<ResponseDto>(accessToken, userId);

        var cart = new CartDto();
        
        if (response?.IsSuccess ?? false)
        {
            cart = JsonConvert.DeserializeObject<CartDto>(Convert.ToString(response.Result));
        }

        if (cart.CartHeader != null)
        {
            foreach (var cartDetails in cart.CartDetails)
            {
                cart.CartHeader.OrderTotal += cartDetails.Count * cartDetails.Product.Price;
            }

            if (!string.IsNullOrEmpty(cart.CartHeader.CouponCode))
            {
                var couponResponse = await _couponService
                    .GetCoupon<ResponseDto>(accessToken, cart.CartHeader.CouponCode);
                
                if (couponResponse?.IsSuccess ?? false)
                {
                    var coupon = JsonConvert.DeserializeObject<CouponDto>(Convert.ToString(couponResponse.Result));
                    cart.CartHeader.DiscountTotal = coupon.DiscountAmount;
                }

                cart.CartHeader.OrderTotal -= cart.CartHeader.DiscountTotal;
            }
        }

        return cart;
    }
}

Mango.Web/Controllers/ProductController.cs
using Mango.Web.Models;
using Mango.Web.Services.Interfaces;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using JsonConverter = System.Text.Json.Serialization.JsonConverter;

namespace Mango.Web.Controllers;

public class ProductController : Controller
{
    private readonly IProductService _productService;

    public ProductController(IProductService productService)
    {
        _productService = productService;
    }

    
    public async Task<IActionResult> Index()
    {
        var accessToken = await HttpContext.GetTokenAsync("access_token");
        var response = await _productService.GetAllProducts<ResponseDto>(accessToken);

        if (response.IsSuccess && response.Result != null)
        {
            var products = JsonConvert.DeserializeObject<List<ProductDto>>(response.Result.ToString());
            return View(products);
        }

        throw new NotImplementedException("Exception handler is not implemented yet");
    }
    
    public async Task<IActionResult> ProductCreate()
    {
        return View();
    }
    
    [HttpPost]
    [ValidateAntiForgeryToken]
    public async Task<IActionResult> ProductCreate(ProductDto model)
    {
        if (ModelState.IsValid)
        {
            var accessToken = await HttpContext.GetTokenAsync("access_token");
            var response = await _productService.CreateProduct<ResponseDto>(accessToken, model);

            if (response.IsSuccess && response.Result != null)
            {
                return RedirectToAction(nameof(Index));
            }
        }

        throw new NotImplementedException("Exception handler is not implemented yet");
    }
    
    public async Task<IActionResult> ProductEdit(int productId)
    {
        var accessToken = await HttpContext.GetTokenAsync("access_token");
        var response = await _productService.GetProductById<ResponseDto>(accessToken, productId);

        if (response.IsSuccess && response.Result != null)
        {
            return View(JsonConvert.DeserializeObject<ProductDto>(response.Result.ToString()));
        }

        return NotFound();
    }
    
    [HttpPost]
    [ValidateAntiForgeryToken]
    public async Task<IActionResult> ProductEdit(ProductDto model)
    {
        if (ModelState.IsValid)
        {
            var accessToken = await HttpContext.GetTokenAsync("access_token");
            var response = await _productService.UpdateProduct<ResponseDto>(accessToken, model);

            if (response.IsSuccess && response.Result != null)
            {
                return RedirectToAction(nameof(Index));
            }
        }

        throw new NotImplementedException("Exception handler is not implemented yet");
    }
    
    [Authorize(Roles = "Admin")]
    public async Task<IActionResult> ProductDelete(int productId)
    {
        var accessToken = await HttpContext.GetTokenAsync("access_token");
        var response = await _productService.GetProductById<ResponseDto>(accessToken, productId);

        if (response.IsSuccess && response.Result != null)
        {
            return View(JsonConvert.DeserializeObject<ProductDto>(response.Result.ToString()));
        }

        return NotFound();
    }
    
    [HttpPost]
    [ValidateAntiForgeryToken]
    public async Task<IActionResult> ProductDelete(ProductDto model)
    {
        if (ModelState.IsValid)
        {
            var accessToken = await HttpContext.GetTokenAsync("access_token");
            var response = await _productService.DeleteProduct<ResponseDto>(accessToken, model.ProductId);

            if (response.IsSuccess && response.Result != null)
            {
                return RedirectToAction(nameof(Index));
            }
        }

        throw new NotImplementedException("Exception handler is not implemented yet");
    }
}

Mango.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>@ViewData["Title"] - Mango</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css"/>
    <link rel="stylesheet" href="~/css/bootstrap-datetimepicker.css" asp-append-version="true"/>
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true"/>
    <link rel="stylesheet" href="~/Mango.Web.styles.css" asp-append-version="true"/>
    <link rel="icon" type="image/x-icon" href="~/favicon.ico">
</head>
<body>
<header>
    <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-dark bg-dark border-bottom box-shadow mb-3">
        <div class="container-fluid">
            <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">
                <img src="https://dotnetmasterpet.blob.core.windows.net/mango/mango-logo.png" width="35px"/>
                <span class="pt-lg-2">Mango</span>
            </a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                    aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                <partial name="_LoginPartial"/>
                <ul class="navbar-nav flex-grow-1">
                    <li class="nav-item">
                        <a class="nav-link pt-lg-2" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link pt-lg-2" asp-area="" asp-controller="Product" asp-action="Index">Products</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link pt-lg-2" asp-controller="Cart" asp-action="Index">
                            <i class="fas fa-shopping-cart"></i>
                        </a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>
</header>
<div class="container">
    <main role="main" class="pb-3">
        @RenderBody()
    </main>
</div>

<footer class="border-top footer text-muted bg-dark">
    <div class="container">
        &copy; 2022 - Mango
    </div>
</footer>
<script src="~/lib/jquery/dist/jquery.min.js"></script>
<script src="https://kit.fontawesome.com/de69536109.js" crossorigin="anonymous"></script>
<script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
<script src="~/js/bootstrap-datetimepicker.js" asp-append-version="true"></script>
<script src="~/js/site.js" asp-append-version="true"></script>
@await RenderSectionAsync("Scripts", required: false)
</body>
</html>